diff --git a/tensorflow/python/client/session_partial_run_test.py b/tensorflow/python/client/session_partial_run_test.py
index a97930635af..0d00670eec4 100644
--- a/tensorflow/python/client/session_partial_run_test.py
+++ b/tensorflow/python/client/session_partial_run_test.py
@@ -19,7 +19,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.client import session
 from tensorflow.python.framework import common_shapes
@@ -96,18 +95,18 @@ class PartialRunTest(test_util.TensorFlowTestCase):
     inputs = []
     outputs = []
     a = constant_op.constant(2.0, dtypes.float32)
-    for i in xrange(steps):
+    for i in range(steps):
       inputs.append(array_ops.placeholder(dtypes.float32, shape=[]))
       a = math_ops.multiply(a, inputs[i])
       outputs.append(a)
 
     h = sess.partial_run_setup(outputs, inputs)
-    for i in xrange(steps):
+    for i in range(steps):
       res = sess.partial_run(h, outputs[i], feed_dict={inputs[i]: 1.0})
     self.assertEqual(2.0, res)
 
     feed_dict = {}
-    for i in xrange(steps):
+    for i in range(steps):
       feed_dict[inputs[i]] = 1.0
     res = sess.run(outputs, feed_dict)
     self.assertEqual(steps, len(res))
diff --git a/tensorflow/python/client/session_test.py b/tensorflow/python/client/session_test.py
index e407a541fcd..85fe81d467f 100644
--- a/tensorflow/python/client/session_test.py
+++ b/tensorflow/python/client/session_test.py
@@ -27,7 +27,6 @@ import warnings
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import attr_value_pb2
 from tensorflow.core.lib.core import error_codes_pb2
@@ -1551,7 +1550,7 @@ class SessionTest(test_util.TensorFlowTestCase):
         for s in shape:
           size *= s
         c_list = np.array(
-            [compat.as_bytes(str(i)) for i in xrange(size)],
+            [compat.as_bytes(str(i)) for i in range(size)],
             dtype=np.object).reshape(shape) if size > 0 else []
         c = constant_op.constant(c_list)
         self.assertAllEqual(c.eval(), c_list)
@@ -1563,7 +1562,7 @@ class SessionTest(test_util.TensorFlowTestCase):
         for s in shape:
           size *= s
         c_list = np.array(
-            [compat.as_bytes(str(i)) for i in xrange(size)],
+            [compat.as_bytes(str(i)) for i in range(size)],
             dtype=np.object).reshape(shape)
         feed_t = array_ops.placeholder(dtype=dtypes.string, shape=shape)
         c = array_ops.identity(feed_t)
@@ -1760,7 +1759,7 @@ class SessionTest(test_util.TensorFlowTestCase):
         b = math_ops.add(a, a)
         c = array_ops.identity(b)
         d = math_ops.multiply(c, c)
-      for step in xrange(120):
+      for step in range(120):
         run_metadata = config_pb2.RunMetadata()
         sess.run(
             d,
diff --git a/tensorflow/python/compiler/xla/xla.py b/tensorflow/python/compiler/xla/xla.py
index 55bfaeb3931..bc54f40a5f4 100644
--- a/tensorflow/python/compiler/xla/xla.py
+++ b/tensorflow/python/compiler/xla/xla.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import collections
 import contextlib
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.jit.ops import xla_ops
 from tensorflow.compiler.jit.ops import xla_ops_grad  # pylint: disable=unused-import
@@ -220,7 +219,7 @@ class XLACompileContext(control_flow_ops.XLAControlFlowContext):
         op._add_control_input(self._pivot)
         # pylint: enable=protected-access
     else:
-      for index in xrange(len(op.inputs)):
+      for index in range(len(op.inputs)):
         x = op.inputs[index]
         real_x = self.AddValue(x)
         if real_x is not x:
diff --git a/tensorflow/python/data/experimental/benchmarks/rejection_resample_benchmark.py b/tensorflow/python/data/experimental/benchmarks/rejection_resample_benchmark.py
index 28253b19ece..52552d9d935 100644
--- a/tensorflow/python/data/experimental/benchmarks/rejection_resample_benchmark.py
+++ b/tensorflow/python/data/experimental/benchmarks/rejection_resample_benchmark.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 import time
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.client import session
 from tensorflow.python.data.experimental.ops import resampling
@@ -46,7 +45,7 @@ def _time_resampling(data_np, target_dist, init_dist, num_to_sample):  # pylint:
 
   with session.Session() as sess:
     start_time = time.time()
-    for _ in xrange(num_to_sample):
+    for _ in range(num_to_sample):
       sess.run(get_next)
     end_time = time.time()
 
diff --git a/tensorflow/python/data/experimental/kernel_tests/parallel_interleave_test.py b/tensorflow/python/data/experimental/kernel_tests/parallel_interleave_test.py
index 1fe5655ec02..21d771bf05c 100644
--- a/tensorflow/python/data/experimental/kernel_tests/parallel_interleave_test.py
+++ b/tensorflow/python/data/experimental/kernel_tests/parallel_interleave_test.py
@@ -23,7 +23,7 @@ import threading
 import time
 
 import numpy as np
-from six.moves import zip_longest
+from itertools import zip_longest
 
 from tensorflow.python.data.experimental.ops import interleave_ops
 from tensorflow.python.data.kernel_tests import test_base
diff --git a/tensorflow/python/data/ops/dataset_ops.py b/tensorflow/python/data/ops/dataset_ops.py
index cad80d37a45..6b444c1e38e 100644
--- a/tensorflow/python/data/ops/dataset_ops.py
+++ b/tensorflow/python/data/ops/dataset_ops.py
@@ -26,7 +26,7 @@ import weakref
 
 import numpy as np
 import six
-from six.moves import queue as Queue  # pylint: disable=redefined-builtin
+import queue as Queue
 
 
 from tensorflow.core.framework import graph_pb2
@@ -700,7 +700,7 @@ class DatasetV2(tracking_base.Trackable, composite_tensor.CompositeTensor):
     ```
 
     Args:
-      *args: follows the same semantics as python's xrange.
+      *args: follows the same semantics as python's range.
         len(args) == 1 -> start = 0, stop = args[0], step = 1
         len(args) == 2 -> start = args[0], stop = args[1], step = 1
         len(args) == 3 -> start = args[0], stop = args[1, stop = args[2]
diff --git a/tensorflow/python/data/util/traverse.py b/tensorflow/python/data/util/traverse.py
index 12e576fb414..103021765d3 100644
--- a/tensorflow/python/data/util/traverse.py
+++ b/tensorflow/python/data/util/traverse.py
@@ -17,7 +17,7 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import queue as Queue  # pylint: disable=redefined-builtin
+import queue as Queue
 
 from tensorflow.python.framework import dtypes
 
diff --git a/tensorflow/python/debug/cli/analyzer_cli.py b/tensorflow/python/debug/cli/analyzer_cli.py
index 5c21b1518ed..d022525f2ad 100644
--- a/tensorflow/python/debug/cli/analyzer_cli.py
+++ b/tensorflow/python/debug/cli/analyzer_cli.py
@@ -25,7 +25,6 @@ import argparse
 import copy
 import re
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.debug.cli import cli_config
 from tensorflow.python.debug.cli import cli_shared
@@ -1422,7 +1421,7 @@ class DebugAnalyzer(object):
 
     # Create depth-dependent hanging indent for the line.
     hang = ""
-    for k in xrange(depth):
+    for k in range(depth):
       if k < depth - 1:
         if k + 1 in unfinished:
           hang += HANG_UNFINISHED
diff --git a/tensorflow/python/debug/cli/analyzer_cli_test.py b/tensorflow/python/debug/cli/analyzer_cli_test.py
index 795849843f4..9ffc98791ae 100644
--- a/tensorflow/python/debug/cli/analyzer_cli_test.py
+++ b/tensorflow/python/debug/cli/analyzer_cli_test.py
@@ -22,7 +22,6 @@ import shutil
 import tempfile
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.core.protobuf import rewriter_config_pb2
@@ -382,7 +381,7 @@ def assert_node_attribute_lines(tst,
     tst.assertEqual("", next(line_iter))
 
     dump_timestamps_ms = []
-    for _ in xrange(num_dumped_tensors):
+    for _ in range(num_dumped_tensors):
       line = next(line_iter)
 
       tst.assertStartsWith(line.strip(), "Slot 0 @ DebugIdentity @")
@@ -1516,10 +1515,10 @@ class AnalyzerCLISimpleMulAddTest(test_util.TensorFlowTestCase):
     out = self._registry.dispatch_command("list_source", [])
 
     non_tf_lib_files_start = [
-        i for i in xrange(len(out.lines))
+        i for i in range(len(out.lines))
         if out.lines[i].startswith("Source file path")][0] + 1
     non_tf_lib_files_end = [
-        i for i in xrange(len(out.lines))
+        i for i in range(len(out.lines))
         if out.lines[i].startswith("TensorFlow Python library file(s):")][0] - 1
     non_tf_lib_files = [
         line.split(" ")[0] for line
@@ -1527,7 +1526,7 @@ class AnalyzerCLISimpleMulAddTest(test_util.TensorFlowTestCase):
     self.assertIn(self._curr_file_path, non_tf_lib_files)
 
     # Check that the TF library files are marked with special color attribute.
-    for i in xrange(non_tf_lib_files_end + 1, len(out.lines)):
+    for i in range(non_tf_lib_files_end + 1, len(out.lines)):
       if not out.lines[i]:
         continue
       for attr_seg in  out.font_attr_segs[i]:
@@ -1541,10 +1540,10 @@ class AnalyzerCLISimpleMulAddTest(test_util.TensorFlowTestCase):
     self.assertStartsWith(out.lines[1], "Node name regex filter: \".*/read\"")
 
     non_tf_lib_files_start = [
-        i for i in xrange(len(out.lines))
+        i for i in range(len(out.lines))
         if out.lines[i].startswith("Source file path")][0] + 1
     non_tf_lib_files_end = [
-        i for i in xrange(len(out.lines))
+        i for i in range(len(out.lines))
         if out.lines[i].startswith("TensorFlow Python library file(s):")][0] - 1
     non_tf_lib_files = [
         line.split(" ")[0] for line
@@ -1552,7 +1551,7 @@ class AnalyzerCLISimpleMulAddTest(test_util.TensorFlowTestCase):
     self.assertIn(self._curr_file_path, non_tf_lib_files)
 
     # Check that the TF library files are marked with special color attribute.
-    for i in xrange(non_tf_lib_files_end + 1, len(out.lines)):
+    for i in range(non_tf_lib_files_end + 1, len(out.lines)):
       if not out.lines[i]:
         continue
       for attr_seg in  out.font_attr_segs[i]:
@@ -2071,7 +2070,7 @@ class AnalyzerCLIWhileLoopTest(test_util.TensorFlowTestCase):
     self.assertEqual("Tensor \"while/Identity:0\" generated 10 dumps:",
                      output.lines[0])
 
-    for i in xrange(10):
+    for i in range(10):
       self.assertTrue(output.lines[i + 1].startswith("#%d" % i))
       self.assertTrue(output.lines[i + 1].endswith(
           " ms] while/Identity:0:DebugIdentity"))
@@ -2083,7 +2082,7 @@ class AnalyzerCLIWhileLoopTest(test_util.TensorFlowTestCase):
     self.assertEqual("  print_tensor while/Identity:0 -n 0", output.lines[-1])
 
   def testMultipleDumpsPrintTensorWithNumber(self):
-    for i in xrange(5):
+    for i in range(5):
       output = self._registry.dispatch_command(
           "pt", ["while/Identity:0", "-n", "%d" % i])
 
diff --git a/tensorflow/python/debug/cli/curses_ui.py b/tensorflow/python/debug/cli/curses_ui.py
index 7b87972d694..ccbce81e661 100644
--- a/tensorflow/python/debug/cli/curses_ui.py
+++ b/tensorflow/python/debug/cli/curses_ui.py
@@ -25,7 +25,6 @@ import signal
 import sys
 import threading
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.debug.cli import base_ui
 from tensorflow.python.debug.cli import cli_shared
@@ -179,7 +178,7 @@ class ScrollBar(object):
 
       layout = debugger_cli_common.RichTextLines(
           [up_text], font_attr_segs={0: [(0, width, self.BASE_ATTR)]})
-      for i in xrange(1, self._scroll_bar_height - 1):
+      for i in range(1, self._scroll_bar_height - 1):
         font_attr_segs = foreground_font_attr_segs if i == block_y else None
         layout.append(empty_line, font_attr_segs=font_attr_segs)
       layout.append(down_text, font_attr_segs=foreground_font_attr_segs)
@@ -965,7 +964,7 @@ class CursesUI(base_ui.BaseUI):
     """Erase existing text in command textpad."""
 
     existing_len = len(self._command_textbox.gather())
-    for _ in xrange(existing_len):
+    for _ in range(existing_len):
       self._command_textbox.do_command(self.BACKSPACE_KEY)
 
   def _screen_draw_text_line(self, row, line, attr=curses.A_NORMAL, color=None):
@@ -1159,7 +1158,7 @@ class CursesUI(base_ui.BaseUI):
     # Create new output pad.
     pad = self._screen_new_output_pad(rows, cols)
 
-    for i in xrange(len(output.lines)):
+    for i in range(len(output.lines)):
       if i in output.font_attr_segs:
         self._screen_add_line_to_output_pad(
             pad, i, output.lines[i], color_segments=output.font_attr_segs[i])
diff --git a/tensorflow/python/debug/cli/tensor_format.py b/tensorflow/python/debug/cli/tensor_format.py
index 374fcd58bc3..cd2733f3212 100644
--- a/tensorflow/python/debug/cli/tensor_format.py
+++ b/tensorflow/python/debug/cli/tensor_format.py
@@ -21,7 +21,6 @@ import copy
 import re
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.debug.cli import debugger_cli_common
 from tensorflow.python.debug.lib import debug_data
@@ -273,7 +272,7 @@ def _annotate_ndarray_lines(
       else:
         if curr_dim > 0:
           curr_indices[curr_dim - 1] += 1
-          for k in xrange(curr_dim, ndims):
+          for k in range(curr_dim, ndims):
             curr_indices[k] = 0
 
   return annotations
@@ -348,7 +347,7 @@ def locate_tensor_element(formatted, indices):
 
   batch_pos = 0  # Current position in the batch.
 
-  for r in xrange(len(lines)):
+  for r in range(len(lines)):
     if r not in annot:
       continue
 
diff --git a/tensorflow/python/debug/examples/debug_fibonacci.py b/tensorflow/python/debug/examples/debug_fibonacci.py
index 870a6d6813a..6313d06c421 100644
--- a/tensorflow/python/debug/examples/debug_fibonacci.py
+++ b/tensorflow/python/debug/examples/debug_fibonacci.py
@@ -21,7 +21,6 @@ import argparse
 import sys
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow
 
 from tensorflow.python import debug as tf_debug
@@ -40,7 +39,7 @@ def main(_):
   n1 = tf.Variable(
       np.ones([FLAGS.tensor_size] * 2), dtype=tf.int32, name="node_01")
 
-  for i in xrange(2, FLAGS.length):
+  for i in range(2, FLAGS.length):
     n0, n1 = n1, tf.add(n0, n1, name="node_%.2d" % i)
 
   sess.run(tf.global_variables_initializer())
diff --git a/tensorflow/python/debug/lib/debug_utils.py b/tensorflow/python/debug/lib/debug_utils.py
index eb21694ba2f..f4b599b7038 100644
--- a/tensorflow/python/debug/lib/debug_utils.py
+++ b/tensorflow/python/debug/lib/debug_utils.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import re
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 
 def add_debug_tensor_watch(run_options,
@@ -163,7 +162,7 @@ def watch_graph(run_options,
     if op_type_pattern and not op_type_pattern.match(op_type):
       continue
 
-    for slot in xrange(len(op.outputs)):
+    for slot in range(len(op.outputs)):
       if (tensor_dtype_pattern and
           not tensor_dtype_pattern.match(op.outputs[slot].dtype.name)):
         continue
@@ -273,7 +272,7 @@ def watch_graph_with_blacklists(run_options,
     if op_type_pattern and op_type_pattern.match(op_type):
       continue
 
-    for slot in xrange(len(op.outputs)):
+    for slot in range(len(op.outputs)):
       if (tensor_dtype_pattern and
           tensor_dtype_pattern.match(op.outputs[slot].dtype.name)):
         continue
diff --git a/tensorflow/python/debug/lib/dist_session_debug_grpc_test.py b/tensorflow/python/debug/lib/dist_session_debug_grpc_test.py
index 0dc01748b08..129101329e4 100644
--- a/tensorflow/python/debug/lib/dist_session_debug_grpc_test.py
+++ b/tensorflow/python/debug/lib/dist_session_debug_grpc_test.py
@@ -26,7 +26,6 @@ import sys
 import time
 
 import portpicker
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python.client import session
@@ -159,7 +158,7 @@ class DistributedSessionDebugTest(test_util.TensorFlowTestCase):
           debug_ops=["DebugIdentity(gated_grpc=True)"],
           debug_urls=[self.debug_server_url])
 
-      for i in xrange(4):
+      for i in range(4):
         if i % 2 == 0:
           self.debug_server.request_watch("p", 0, "DebugIdentity")
         else:
@@ -214,7 +213,7 @@ class DistributedSessionDebugTest(test_util.TensorFlowTestCase):
       sess = grpc_wrapper.GrpcDebugWrapperSession(
           sess, "localhost:%d" % self.debug_server_port, watch_fn=watch_fn)
 
-      for i in xrange(4):
+      for i in range(4):
         expected_p = (10.0 + 2.0 * (i + 1)) * (100.0 - 5.0 * (i + 1))
         self.assertAllClose(-expected_p, sess.run(self.q))
 
diff --git a/tensorflow/python/debug/lib/grpc_large_data_test.py b/tensorflow/python/debug/lib/grpc_large_data_test.py
index 64d5a241531..d362b40d80d 100644
--- a/tensorflow/python/debug/lib/grpc_large_data_test.py
+++ b/tensorflow/python/debug/lib/grpc_large_data_test.py
@@ -21,7 +21,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.debug.lib import grpc_debug_test_server
 from tensorflow.python.debug.lib import session_debug_testlib
@@ -63,7 +62,7 @@ class LargeGraphAndLargeTensorsDebugTest(test_util.TensorFlowTestCase):
         use_gpu=True,
         config=session_debug_testlib.no_rewrite_session_config()) as sess:
       u = variables.VariableV1(42.0, name="original_u")
-      for _ in xrange(50 * 1000):
+      for _ in range(50 * 1000):
         u = array_ops.identity(u)
       sess.run(variables.global_variables_initializer())
 
@@ -91,7 +90,7 @@ class LargeGraphAndLargeTensorsDebugTest(test_util.TensorFlowTestCase):
     with self.session(
         use_gpu=True,
         config=session_debug_testlib.no_rewrite_session_config()) as sess:
-      u_init_val_array = list(xrange(1200 * 1024))
+      u_init_val_array = list(range(1200 * 1024))
       # Size: 4 * 1200 * 1024 = 4800k > 4M
 
       u_init = constant_op.constant(
diff --git a/tensorflow/python/debug/lib/session_debug_grpc_test.py b/tensorflow/python/debug/lib/session_debug_grpc_test.py
index f3b187cb3e9..5cba4f8f3ef 100644
--- a/tensorflow/python/debug/lib/session_debug_grpc_test.py
+++ b/tensorflow/python/debug/lib/session_debug_grpc_test.py
@@ -24,7 +24,6 @@ from __future__ import print_function
 import os
 import shutil
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python.client import session
@@ -401,7 +400,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
                      "DebugNumericSummary(gated_grpc=true)"],
           debug_urls=[self._debug_server_url_1])
 
-      for i in xrange(4):
+      for i in range(4):
         self._server_1.clear_data()
 
         if i % 2 == 0:
@@ -473,7 +472,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
           debug_ops=["DebugIdentity(gated_grpc=true)"],
           debug_urls=[debug_server_url])
 
-      for i in xrange(4):
+      for i in range(4):
         server.clear_data()
 
         sess.run([inc_v_1, inc_v_2],
@@ -507,7 +506,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
           debug_ops=["DebugIdentity(gated_grpc=true)"],
           debug_urls=[self._debug_server_url_1, self._debug_server_url_2])
 
-      for i in xrange(4):
+      for i in range(4):
         self._server_1.clear_data()
         self._server_2.clear_data()
 
@@ -553,7 +552,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
           debug_ops=["DebugIdentity(gated_grpc=true)"],
           debug_urls=[self._debug_server_url_1])
 
-      for i in xrange(4):
+      for i in range(4):
         self._server_1.clear_data()
 
         if i in (0, 2):
@@ -608,7 +607,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
       sess = grpc_wrapper.TensorBoardDebugWrapperSession(
           sess, self._debug_server_url_1)
 
-      for i in xrange(4):
+      for i in range(4):
         self._server_1.clear_data()
 
         if i in (0, 2):
@@ -680,7 +679,7 @@ class SessionDebugGrpcGatingTest(test_util.TensorFlowTestCase):
       sess = grpc_wrapper.TensorBoardDebugWrapperSession(
           sess, self._debug_server_url_1, send_traceback_and_source_code=False)
 
-      for i in xrange(4):
+      for i in range(4):
         self._server_1.clear_data()
 
         if i == 0:
diff --git a/tensorflow/python/debug/lib/session_debug_testlib.py b/tensorflow/python/debug/lib/session_debug_testlib.py
index e2740d80705..25f0384b681 100644
--- a/tensorflow/python/debug/lib/session_debug_testlib.py
+++ b/tensorflow/python/debug/lib/session_debug_testlib.py
@@ -26,7 +26,6 @@ import tempfile
 import threading
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.core.protobuf import rewriter_config_pb2
@@ -520,7 +519,7 @@ class SessionDebugTestBase(test_util.TensorFlowTestCase):
 
       while_id_tensors = dump.get_tensors("while/Identity", 0, "DebugIdentity")
       self.assertEqual(10, len(while_id_tensors))
-      for k in xrange(len(while_id_tensors)):
+      for k in range(len(while_id_tensors)):
         self.assertAllClose(np.array(k), while_id_tensors[k])
 
       # Verify ascending timestamps from the while loops.
@@ -1488,7 +1487,7 @@ class DebugConcurrentRunCallsTest(test_util.TensorFlowTestCase):
     with session.Session() as sess:
       v = variables.VariableV1(30.0, name="v")
       constants = []
-      for i in xrange(self._num_concurrent_runs):
+      for i in range(self._num_concurrent_runs):
         constants.append(constant_op.constant(1.0, name="c%d" % i))
       incs = [
           state_ops.assign_add(
@@ -1503,11 +1502,11 @@ class DebugConcurrentRunCallsTest(test_util.TensorFlowTestCase):
         run_options = config_pb2.RunOptions(output_partition_graphs=True)
         debug_utils.watch_graph(
             run_options, sess.graph, debug_urls=concurrent_debug_urls[index])
-        for _ in xrange(100):
+        for _ in range(100):
           sess.run(incs[index], options=run_options)
 
       inc_threads = []
-      for index in xrange(self._num_concurrent_runs):
+      for index in range(self._num_concurrent_runs):
         inc_thread = threading.Thread(target=functools.partial(inc_job, index))
         inc_thread.start()
         inc_threads.append(inc_thread)
@@ -1518,7 +1517,7 @@ class DebugConcurrentRunCallsTest(test_util.TensorFlowTestCase):
                           sess.run(v))
 
       all_session_run_indices = []
-      for index in xrange(self._num_concurrent_runs):
+      for index in range(self._num_concurrent_runs):
         dump = debug_data.DebugDumpDir(self._dump_roots[index])
         self.assertTrue(dump.loaded_partition_graphs())
 
@@ -1548,14 +1547,14 @@ class DebugConcurrentRunCallsTest(test_util.TensorFlowTestCase):
         executor_step_indices = zip(timestamps, executor_step_indices)
         executor_step_indices = sorted(
             executor_step_indices, key=lambda x: x[0])
-        for i in xrange(len(executor_step_indices) - 1):
+        for i in range(len(executor_step_indices) - 1):
           self.assertEquals(executor_step_indices[i][1] + 1,
                             executor_step_indices[i + 1][1])
 
         # Assert that session_run_index increase monotonically.
         session_run_indices = zip(timestamps, session_run_indices)
         session_run_indices = sorted(session_run_indices, key=lambda x: x[0])
-        for i in xrange(len(session_run_indices) - 1):
+        for i in range(len(session_run_indices) - 1):
           self.assertGreater(session_run_indices[i + 1][1],
                              session_run_indices[i][1])
 
diff --git a/tensorflow/python/distribute/cluster_resolver/tpu_cluster_resolver.py b/tensorflow/python/distribute/cluster_resolver/tpu_cluster_resolver.py
index 9035cd4681c..934bdddcbf6 100644
--- a/tensorflow/python/distribute/cluster_resolver/tpu_cluster_resolver.py
+++ b/tensorflow/python/distribute/cluster_resolver/tpu_cluster_resolver.py
@@ -22,10 +22,9 @@ import collections
 import os
 import re
 
-from six.moves import urllib
-from six.moves.urllib.error import URLError
-from six.moves.urllib.request import Request
-from six.moves.urllib.request import urlopen
+from urllib.error import URLError
+from urllib.request import Request
+from urllib.request import urlopen
 
 from tensorflow.python.distribute.cluster_resolver.cluster_resolver import ClusterResolver
 from tensorflow.python.distribute.cluster_resolver.cluster_resolver import format_master_url
diff --git a/tensorflow/python/eager/benchmarks_test.py b/tensorflow/python/eager/benchmarks_test.py
index 01d2134da92..3567da3bba0 100644
--- a/tensorflow/python/eager/benchmarks_test.py
+++ b/tensorflow/python/eager/benchmarks_test.py
@@ -31,7 +31,6 @@ import time
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python import keras
 from tensorflow.python import pywrap_tensorflow
@@ -146,7 +145,7 @@ def run_benchmark(func, num_iters, execution_mode=None):
     if execution_mode == context.ASYNC:
       ctx.executor.wait()
     start = time.time()
-    for _ in xrange(num_iters):
+    for _ in range(num_iters):
       func()
     if execution_mode == context.ASYNC:
       ctx.executor.wait()
diff --git a/tensorflow/python/eager/def_function_test.py b/tensorflow/python/eager/def_function_test.py
index 9ab42b63098..2951623efca 100644
--- a/tensorflow/python/eager/def_function_test.py
+++ b/tensorflow/python/eager/def_function_test.py
@@ -21,7 +21,6 @@ import functools
 import re
 import weakref
 
-from six.moves import range
 
 from tensorflow.python.eager import backprop
 from tensorflow.python.eager import def_function
diff --git a/tensorflow/python/eager/monitoring.py b/tensorflow/python/eager/monitoring.py
index 09838f143e0..9bc737199e8 100644
--- a/tensorflow/python/eager/monitoring.py
+++ b/tensorflow/python/eager/monitoring.py
@@ -19,6 +19,7 @@ from __future__ import division
 from __future__ import print_function
 
 import collections
+import weakref
 
 from tensorflow.core.framework import summary_pb2
 from tensorflow.python import pywrap_tensorflow
@@ -119,8 +120,10 @@ class Metric(object):
           self._metric_name, len(self._metric_methods)))
 
     self._metric = self._metric_methods[self._label_length].create(*args)
+    self._finalizer = weakref.finalize(self, self._cleanup, self)
 
-  def __del__(self):
+  @staticmethod
+  def _cleanup(self):
     try:
       deleter = self._metric_methods[self._label_length].delete
       metric = self._metric
